#define DLL_EXPORT   

#ifndef _DLL_TUTORIAL_H_
    #define _DLL_TUTORIAL_H_
    #include <iostream>
     
    #if defined DLL_EXPORT
      #define DECLDIR __declspec(dllexport)
    #else
      #define DECLDIR __declspec(dllimport)
    #endif
     
     
  struct HwId
  {
    CString VendorID;
    CString ProductID;
    bool    IdSet;
    HwId()  { IdSet = false; VendorID.Empty(); ProductID.Empty(); }
  };

  struct PortDetails
  {
    CString PortName;
    CString DevDesc;
    HwId    HardwareID;
    PortDetails() { PortName.Empty(); DevDesc.Empty(); }
  };
  typedef CArray<PortDetails> PortList;

  PortList  m_ComsPorts;
  
     
    extern "C"
    {
        DECLDIR void RA_LEDWrite( unsigned char Port, unsigned char value );
        DECLDIR void RA_LEDOn( unsigned char Port, unsigned char index );
        DECLDIR void RA_LEDOff( unsigned char Port, unsigned char index );
        
        DECLDIR unsigned char RA_SetServo( unsigned char Port, unsigned char Index, unsigned char Position );
        DECLDIR unsigned char RA_SetAllServos( unsigned char Port, unsigned char Position0, unsigned char Position1, unsigned char Position2, unsigned char Position3, unsigned char Position4 );
        DECLDIR unsigned char RA_GripperClose( unsigned char Port, unsigned char Pressure );
        DECLDIR unsigned char RA_GripperOpen( unsigned char Port );
        DECLDIR unsigned char RA_Park( unsigned char Port );
        DECLDIR void RA_SetTrim( unsigned char Port, unsigned char Index, unsigned char Position );
        DECLDIR void RA_StoreCoords( unsigned char Port, unsigned char Index, unsigned char Position0, unsigned char Position1, unsigned char Position2, unsigned char Position3, unsigned char Position4 );
        DECLDIR void RA_StorePosition( unsigned char Port, unsigned char Index );
        DECLDIR unsigned char RA_GotoPosition( unsigned char Port, unsigned char Index );
        
        DECLDIR unsigned char RA_ReadSwitch( unsigned char Port, unsigned char Index );
        DECLDIR unsigned char RA_ReadLight( unsigned char Port );
        DECLDIR unsigned char RA_ReadPot( unsigned char Port );
        DECLDIR unsigned char RA_ReadPressure( unsigned char Port );
        DECLDIR unsigned char RA_ReadMagnet( unsigned char Port );
        DECLDIR unsigned int RA_ReadColour( unsigned char Port );
        DECLDIR unsigned char RA_ReadColourChannel( unsigned char Port, unsigned char Index, unsigned int Colour );
        DECLDIR unsigned char RA_Beep( unsigned char Port, unsigned char Iterations, unsigned int onDelay, unsigned int offDelay );
        
        DECLDIR void RA_LCDClear(unsigned char Port);
        DECLDIR void RA_LCDPrint(unsigned char Port, unsigned char * Text);
        DECLDIR void RA_LCDPrintNumber(unsigned char Port, unsigned int Number);
        DECLDIR void RA_LCDCursor(unsigned char Port, unsigned char X, unsigned char Y );
        DECLDIR void RA_LCDClearLine(unsigned char Port, unsigned char Line );
        DECLDIR void RA_LCDVerbose(unsigned char Port, unsigned char Mode );
        
        DECLDIR unsigned char RA_GetAPIVersion(unsigned char Port);
  		
	    DECLDIR unsigned char RA_ComFindFirst( void );
	    DECLDIR unsigned char RA_ComQuery( unsigned char Port );
	    DECLDIR unsigned char RA_ComOpen( unsigned char Port );
	    DECLDIR unsigned char RA_ComClose( unsigned char Port );
  		
	    DECLDIR void BaudRateSet( unsigned char Port, unsigned long Baud );
	    DECLDIR unsigned int ReadCharCOM( unsigned char Port, unsigned int timeout, unsigned int timeout_val );
	    DECLDIR void SendCharCOM( unsigned char Port, unsigned char Data );
	    DECLDIR void SetDTRStatePrivate( unsigned char Port, unsigned char state );
	    DECLDIR void SetFlowControlPrivate( unsigned char Port, unsigned char state );
    }
     
 #endif
 
 